function z = fm_demod(y,Fc,Fs,freqdev,ini_phase)


if(nargin<5 || isempty(ini_phase) )
    ini_phase = 0;
elseif(~isreal(ini_phase) || ~isscalar(ini_phase)  )
    error(message('comm:fmdemod:InvalidIni_Phase'));
end

if(nargin<4 || isempty(ini_phase) )
    freqdev = 50;
end 

len = size(y,1);
if(len==1)
    y = y(:);
end

t = (0:1/Fs:((size(y,1)-1)/Fs))';
t = t(:,ones(1,size(y,2)));

% /////////////////////////////////////////////////////
Aosc = -1*sin(2*pi*Fc*t+ini_phase);
Bosc = cos(2*pi*Fc*t+ini_phase);

Aosc = Aosc(:);
Bosc = Bosc(:);

A = y .* Aosc; 
B = y .* Bosc;
% ////////////////////////////////////////////////////

% ////////     FFT Low-pass filter 400Hz  /////////////
AF=fft(A); 
AF2=zeros(length(AF),1);
AF2(1:400)=AF(1:400);
Alpf=real(ifft(AF2));

BF=fft(B); 
BF2=zeros(length(BF),1);
BF2(1:400)=BF(1:400);
Blpf=real(ifft(BF2));
% /////////////////////////////////////////////////////


Adiff = [zeros(1,size(y,2)); diff(Alpf)];
Bdiff = [zeros(1,size(y,2)); diff(Blpf)];

z = (((Blpf .* Adiff) + (Alpf .* Bdiff)) ./ (Alpf.^2 + Blpf.^2)) * 65;

if(len == 1)
    z = z';

end